//+------------------------------------------------------------------+
//|                                               exp_cci_mt5_v2.mq5 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"

#resource "\\Include\\Controls\\res\\CloseDisable.bmp"
#resource "\\Include\\Controls\\res\\Close.bmp"
#resource "\\Include\\Controls\\res\\RestoreDisable.bmp"
#resource "\\Include\\Controls\\res\\ExpandDisable.bmp"
#resource "\\Include\\Controls\\res\\TurnOn.bmp"
#resource "\\Include\\Controls\\res\\TurnOff.bmp"

string CloseDisable="::Include\\Controls\\res\\CloseDisable.bmp";
string CloseOff="::Include\\Controls\\res\\Close.bmp";
string RollOn="::Include\\Controls\\res\\RestoreDisable.bmp";
string RollOff="::Include\\Controls\\res\\ExpandDisable.bmp";
string TurnOn="::Include\\Controls\\res\\TurnOn.bmp"; //     On
string TurnOff="::Include\\Controls\\res\\TurnOff.bmp";  //    

                                                         //#include "Panel.mqh"
#include <Controls\Panel.mqh>
#include <Controls\BmpButton.mqh>
#include <Controls\Label.mqh>
#include <Tools\DateTime.mqh>
#include<Indicators\Oscilators.mqh>
#include <Trade\Trade.mqh>

input double Risk=1.0;
input double Ksl=1.618;
input double Ktp=2.618;
input int period_CCI_S=100;
input int period_CCI_F=13;
input int Period_ATR=21;
input ENUM_TIMEFRAMES TF_ATR=PERIOD_CURRENT;
input string CommentOrder="exp_cci";
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool symbol_tester(string symbol)
  {
   if(!MQLInfoInteger(MQL_VISUAL_MODE))return(true);
//if(!MQLInfoInteger(MQL_TESTER))return(true);
//if(!MQLInfoInteger(MQL_OPTIMIZATION))return(true);

   if(symbol=="EURUSD")return(true);
   if(symbol=="AUDUSD")return(true);
   if(symbol=="GBPUSD")return(true);
//if(symbol=="USDCAD")return(true);
   if(symbol=="USDCHF")return(true);
   if(symbol=="USDJPY")return(true);
//if(symbol=="NZDUSD")return(true);
//if(symbol=="GBPCAD")return(true);

   return(false);
  }

CPanel *panel;
CBmpButton *button_c;
CBmpButton *button_r;
CBmpButton *button_t;
CLabel*label;
CDateTime dates;

CiCCI *cci_s;
CiCCI *cci_f;
CiATR *atr;
CTrade           *trade;

int Width;
int Height;

bool show_close=false;
bool show_roll = false;
bool show_turn = false;

bool MarketWatch=true;
int total_symbol;

ENUM_ORDER_TYPE Signal[];
ENUM_ORDER_TYPE trend[];
//MqlTradeRequest   m_request;         // request data
//MqlTradeResult    m_result;          // result data
//MqlTradeCheckResult m_check_result;  // result check data
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- create timer
   EventSetTimer(1);
   panel=new CPanel();
   button_c=new CBmpButton();
   button_r=new CBmpButton();
   button_t=new CBmpButton();
   label=new CLabel();

   if(MQLInfoInteger(MQL_VISUAL_MODE))MarketWatch=false;
//if(MQLInfoInteger(MQL_TESTER))MarketWatch=false;
//if(MQLInfoInteger(MQL_OPTIMIZATION))MarketWatch=false;

   total_symbol=SymbolsTotal(MarketWatch);

   trade=new CTrade();
   cci_s=new CiCCI();
   cci_f=new CiCCI();
   atr=new CiATR();

   ArrayResize(Signal,total_symbol);
   ArrayResize(trend,total_symbol);

   ArrayInitialize(trend,6);

   from_create1();
   from_create3();
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- destroy timer
   EventKillTimer();
   delete(panel);
   delete(button_c);
   delete(button_r);
   delete(button_t);
   delete(label);

   delete(cci_s);
   delete(cci_f);
   delete(atr);
   delete(trade);

   ObjectsDeleteAll(0);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
//void OnTick()
//  {
////---
//
//  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
//void OnTimer()
void OnTick()
  {
   total_symbol=SymbolsTotal(MarketWatch);

   for(int i=0;i<total_symbol;i++)
     {

      string symbol=SymbolName(i,MarketWatch);
      if(!symbol_tester(symbol))continue;
      Signal[i]=Get_Signal(symbol,i);
      double SL=Dynamic_Stop(symbol)*Ksl;
      double TP=Dynamic_Stop(symbol)*Ktp;
      if(Signal[i]==ORDER_TYPE_BUY)
        {
         if(PositionSelect(symbol))
           {
            if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)trade.PositionClose(symbol);
           }
         else
           {
            trade.Buy(Volume(symbol,Risk/total_symbol,SL),symbol,0,0,0,CommentOrder);
           }
        }
      if(Signal[i]==ORDER_TYPE_SELL)
        {
         if(PositionSelect(symbol))
           {
            if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)trade.PositionClose(symbol);
           }
         else
           {
            trade.Sell(Volume(symbol,Risk/total_symbol,SL),symbol,0,0,0,CommentOrder);
           }
        }

      ModifySL(symbol,SL);
      ModifyTP(symbol,TP);
     }
//---
   Width=ChartWidthInPixels();
   Height=ChartHeightInPixelsGet();

   if(!show_turn)
     {
      from_create1();
      from_create3();
     }
   if(show_turn)from_create2();

  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {

//---
   if(id==CHARTEVENT_OBJECT_CLICK)
     {
      if(sparam=="Close")
        {
         show_close=button_c.Pressed();
         if(show_close)ExpertRemove();
        }
      if(sparam=="Roll")
        {
         show_roll=button_r.Pressed();
        }
      if(sparam=="Turn")
        {
         show_turn=button_t.Pressed();
        }

      if(!show_turn)
        {
         from_create1();
         from_create3();
        }
      if(show_turn)from_create2();
     }

  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ModifyTP(string symbol,double tp)
  {
   if(tp<=0)return;
   double _sl=0.0;
   double _tp=0.0;
   if(PositionSelect(symbol))
     {
      if(PositionGetDouble(POSITION_TP)==0)
        {
         double point=SymbolInfoDouble(symbol,SYMBOL_POINT);
         int digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS);

         if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)
           {
            _tp=NormalizeDouble(PositionGetDouble(POSITION_PRICE_OPEN)+tp*point,digits);
            _sl=PositionGetDouble(POSITION_SL);
           }
         if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)
           {
            _tp=NormalizeDouble(PositionGetDouble(POSITION_PRICE_OPEN)-tp*point,digits);
            _sl=PositionGetDouble(POSITION_SL);
           }
         //if(OrderCheck(m_request,m_check_result))
         //  {
         //   if(OrderSend(m_request,m_result)){}
         //   else Print("  - ",m_result.retcode);
         //  }
         trade.PositionModify(symbol,_sl,_tp);
        }
     }
  }
//+------------------------------------------------------------------+
void ModifySL(string symbol,double sl)
  {
   if(sl<=0)return;
   double _sl=0.0;
   double _tp=0.0;
   if(PositionSelect(symbol))
     {
      if(PositionGetDouble(POSITION_SL)==0)
        {
         double point=SymbolInfoDouble(symbol,SYMBOL_POINT);
         int digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS);
         if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)
           {
            _tp=PositionGetDouble(POSITION_TP);
            _sl=NormalizeDouble(PositionGetDouble(POSITION_PRICE_OPEN)-sl*point,digits);
           }
         if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)
           {
            _tp=PositionGetDouble(POSITION_TP);
            _sl=NormalizeDouble(PositionGetDouble(POSITION_PRICE_OPEN)+sl*point,digits);
           }
         //if(OrderCheck(m_request,m_check_result))
         //  {
         //   if(OrderSend(m_request,m_result)){}
         //   else Print("  - ",m_result.retcode);
         //  }
         trade.PositionModify(symbol,_sl,_tp);
        }
     }
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
double Dynamic_Stop(string symbol)
  {
   if(Bars(symbol,TF_ATR)<Period_ATR+1)return(WRONG_VALUE);
   if(!atr.Create(symbol,TF_ATR,Period_ATR))return(WRONG_VALUE);
   atr.Refresh();
   double vol=atr.GetData(0,1)/SymbolInfoDouble(symbol,SYMBOL_POINT);
   return(vol);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double Volume(string symbol,double risk,double sl)
  {
   double lot=0.0;
   double tv=SymbolInfoDouble(symbol,SYMBOL_TRADE_TICK_VALUE_PROFIT);
   double MinLot=SymbolInfoDouble(symbol,SYMBOL_VOLUME_MIN);
   double MaxLot=SymbolInfoDouble(symbol,SYMBOL_VOLUME_MAX);

   if(sl!=0 && tv!=0) lot=(AccountInfoDouble(ACCOUNT_MARGIN_FREE)*risk)/(sl*tv*100.0);
   if(lot<MinLot)lot=MinLot;
   if(lot>MaxLot)lot=MaxLot;

   if(MinLot==0.001) return(NormalizeDouble(lot,3));
   if(MinLot==0.01)  return(NormalizeDouble(lot,2));
   if(MinLot==0.1)   return(NormalizeDouble(lot,1));

   return(NormalizeDouble(lot,0));
  }
//+------------------------------------------------------------------+
ENUM_ORDER_TYPE Get_Signal(string symbol,int index)
  {

   if(Bars(symbol,PERIOD_CURRENT)<period_CCI_S+1)return(WRONG_VALUE);
   if(Bars(symbol,TF_ATR)<Period_ATR+1)return(WRONG_VALUE);

   if(!cci_s.Create(symbol,NULL,period_CCI_S,PRICE_CLOSE))return(WRONG_VALUE);
   if(!cci_f.Create(symbol,NULL,period_CCI_F,PRICE_CLOSE))return(WRONG_VALUE);
   if(!atr.Create(symbol,TF_ATR,Period_ATR))return(WRONG_VALUE);

   cci_s.Refresh();
   cci_f.Refresh();

   double CCI_S1=cci_s.GetData(0,1);
   double CCI_S2=cci_s.GetData(0,2);
   double CCI_F1=cci_f.GetData(0,1);
   double CCI_F2=cci_f.GetData(0,2);

   if(CCI_S1>100.0)trend[index]=ORDER_TYPE_BUY;
   if(CCI_S1<-100.0)trend[index]=ORDER_TYPE_SELL;

   if(CCI_S1>100.0  &&  CCI_S2<100.0)trend[index]=ORDER_TYPE_BUY;
   if(CCI_S1<-100.0 && CCI_S2>-100.0)trend[index]=ORDER_TYPE_SELL;

   if(trend[index]==ORDER_TYPE_BUY)
     {
      if(CCI_F1<-100.0)return(ORDER_TYPE_BUY);
      if(CCI_F1<-100.0 && CCI_F2>-100.0)return(ORDER_TYPE_BUY);
      if(CCI_F1>-100.0 && CCI_F2<-100.0)return(ORDER_TYPE_BUY);
      if(CCI_F1>100.0 && CCI_F2<100.0)return(ORDER_TYPE_BUY);
      if(CCI_F1>100.0)return(ORDER_TYPE_BUY);
     }
   if(trend[index]==ORDER_TYPE_SELL)
     {
      if(CCI_F1>100)return(ORDER_TYPE_SELL);
      if(CCI_F1>100 && CCI_F2<100)return(ORDER_TYPE_SELL);
      if(CCI_F1<100 && CCI_F2>100)return(ORDER_TYPE_SELL);
      if(CCI_F1<-100 && CCI_F2>-100)return(ORDER_TYPE_SELL);
      if(CCI_F1<-100)return(ORDER_TYPE_SELL);
     }

   return(WRONG_VALUE);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
void from_create1()
  {
   int x=Width-20;

   panel.Create(0,"Panel",0,0,0,Width-20,20);
   panel.BorderType(BORDER_RAISED);
   panel.ColorBackground(clrDodgerBlue);

   button_c.Create(0,"Close",0,Width-40,0,Width-20,20);
   button_c.BmpNames(CloseDisable,CloseOff);
   button_c.Pressed(show_close);

   button_r.Create(0,"Roll",0,Width-60,0,Width-40,20);
   button_r.BmpNames(RollOn,RollOff);
   button_r.Pressed(show_roll);

   button_t.Create(0,"Turn",0,Width-80,2,Width-60,22);
   button_t.BmpNames(TurnOn,TurnOff);
   button_t.Pressed(show_turn);

   label.Create(0,"Time",0,Width-280,0,0,0);
   label.Font("");
   label.Text(TimeToString(TimeCurrent(),TIME_DATE|TIME_SECONDS)+" : "+dates.DayName());
   label.Color(clrWhite);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void from_create2()
  {
//int x=80;
   int y=Height-20;

   panel.Create(0,"Panel",0,3,y,60,Height);
   panel.BorderType(BORDER_RAISED);
   panel.ColorBackground(clrDodgerBlue);

   button_c.Create(0,"Close",0,42,y,Width-20,20);
   button_c.BmpNames(CloseDisable,CloseOff);
   button_c.Pressed(show_close);

   button_r.Create(0,"Roll",0,22,y,Width-40,20);
   button_r.BmpNames(RollOn,RollOff);
   button_r.Pressed(show_roll);

   button_t.Create(0,"Turn",0,5,Height-18,60,Height);
   button_t.BmpNames(TurnOn,TurnOff);
   button_t.Pressed(show_turn);


  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void from_create3()
  {

   panel.Create(0,"Panel",0,0,0,Width-20,20);
   panel.BorderType(BORDER_RAISED);
   panel.ColorBackground(clrDodgerBlue);

   button_c.Create(0,"Close",0,Width-40,0,Width-20,20);
   button_c.BmpNames(CloseDisable,CloseOff);
   button_c.Pressed(show_close);

   button_r.Create(0,"Roll",0,Width-60,0,Width-40,20);
   button_r.BmpNames(RollOn,RollOff);
   button_r.Pressed(show_roll);

   button_t.Create(0,"Turn",0,Width-80,2,Width-60,22);
   button_t.BmpNames(TurnOn,TurnOff);
   button_t.Pressed(show_turn);

   panel.Create(0,"Panel2",0,0,20,Width-20,Height);
   panel.BorderType(BORDER_SUNKEN);
   panel.ColorBackground(clrWhiteSmoke);
//panel.ColorBorder(clrWhiteSmoke);
   int x = 5;
   int y = 25;

   for(int i=0;i<total_symbol;i++)
     {
      if(!symbol_tester(SymbolName(i,MarketWatch)))continue;
      label.Create(0,SymbolName(i,MarketWatch),0,x,y,0,0);
      label.Font("");
      label.Text(SymbolName(i,MarketWatch));
      label.Color(clrGreen);

      label.Create(0,"_"+(string)i,0,x+60,y,0,0);
      label.Font("");
      label.Text(":");
      label.Color(clrBlue);

      label.Create(0,"Arrow__"+(string)i,0,x+100,y,0,0);
      label.Font("Wingdings");
      label.Text(CharToString((uchar)arrow(trend[i])));
      label.Color(Colorarrow(trend[i]));

      label.Create(0,"_"+(string)i,0,x+120,y,0,0);
      label.Font("");
      label.Text(":");
      label.Color(clrBlue);

      label.Create(0,"Arrow__"+(string)i,0,x+170,y,0,0);
      label.Font("Wingdings");
      label.Text(CharToString((uchar)arrow(Signal[i])));
      label.Color(Colorarrow(Signal[i]));

      y+=15;
      if(y>=Height-20)
        {
         x+=200;
         y=25;
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int arrow(ENUM_ORDER_TYPE sig)
  {
   if(sig==WRONG_VALUE)return(251);
   if(sig==ORDER_TYPE_BUY)return(233);
   if(sig==ORDER_TYPE_SELL)return(234);
   return(0);
  }
//+------------------------------------------------------------------+
color Colorarrow(ENUM_ORDER_TYPE sig)
  {
   if(sig==WRONG_VALUE)return(clrMediumAquamarine);
   if(sig==ORDER_TYPE_BUY)return(clrBlue);
   if(sig==ORDER_TYPE_SELL)return(clrRed);
   return(0);
  }
//+------------------------------------------------------------------+
//|       .             |
//+------------------------------------------------------------------+
int ChartWidthInPixels(const long chart_ID=0)
  {
//---      
   long result=-1;
//---   
   ResetLastError();
//---   
   if(!ChartGetInteger(chart_ID,CHART_WIDTH_IN_PIXELS,0,result))
     {
      //---       ""
      Print(__FUNCTION__+", Error Code = ",GetLastError());
     }
//---    
   return((int)result);
  }
//+------------------------------------------------------------------+
//|       .             |
//+------------------------------------------------------------------+
int ChartHeightInPixelsGet(const long chart_ID=0,const int sub_window=0)
  {
//---      
   long result=-1;
//---   
   ResetLastError();
//---   
   if(!ChartGetInteger(chart_ID,CHART_HEIGHT_IN_PIXELS,sub_window,result))
     {
      //---       ""
      Print(__FUNCTION__+", Error Code = ",GetLastError());
     }
//---    
   return((int)result);
  }
//+------------------------------------------------------------------+
